package com.testSildingTextView;

import android.content.Context;
import android.content.res.TypedArray;
import android.os.Handler;
import android.os.Message;
import android.util.AttributeSet;
import android.view.View;
import android.view.animation.Animation;
import android.view.animation.TranslateAnimation;
import android.view.animation.Animation.AnimationListener;
import android.widget.Button;
import android.widget.LinearLayout;
import android.widget.TextView;

public class SlidingTextView extends LinearLayout {

	private String[] showTexts = new String[] { "ssssss", "aaaaaa", "bbbbbb" };
	// ¼ʾĸַ
	private int count = 0;
	private int mDuration;
	private TextView text;
	private int textWidth = 200;

	public SlidingTextView(Context context, AttributeSet attrs) {
		super(context, attrs);
		TypedArray a = context.obtainStyledAttributes(attrs,
				R.styleable.SlidingText);
		mDuration = a
				.getInteger(R.styleable.SlidingText_animationDuration, 750);
	}
	
	//Ҫʾַ
	public void setShowText(String[] showTexts){
		this.showTexts=showTexts;
	}

	// ص ʼʱ
	protected void onFinishInflate() {
		super.onFinishInflate();

		text = (TextView) this.getChildAt(0);

		mHandler.postDelayed(appear, 1000);
	}


	@Override
	// ص ʱView /߶ ȷ
	protected void onLayout(boolean changed, int l, int t, int r, int b) {
		super.onLayout(changed, l, t, r, b);
		textWidth = text.getWidth();
	}

	private Handler mHandler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			// 1Ϊ֣2Ϊ
			switch (msg.arg1) {
			case 1:
				doAnimationOpen();
				break;
			case 2:
				doAnimationClose();
				break;
			}
		}
	};

	public void doAnimationOpen() {
		post(appear);
	}

	// ֵЧ
	Runnable appear = new Runnable() {
		public void run() {
			TranslateAnimation animation;
			int fromXDelta = 0, toXDelta = 0, fromYDelta = 0, toYDelta = 0;
			int calculatedDuration = 0;

			fromXDelta = textWidth;
			toXDelta = 0;
			calculatedDuration = mDuration * Math.abs(toXDelta - fromXDelta)
					/ textWidth;

			animation = new TranslateAnimation(fromXDelta, toXDelta,
					fromYDelta, toYDelta);
			animation.setDuration(calculatedDuration);
			animation.setAnimationListener(new AnimationListener() {

				@Override
				public void onAnimationStart(Animation animation) {
					if(showTexts.length!=0){
						count = (count + 1) % showTexts.length;
						text.setText(showTexts[count]);
					}
					text.setVisibility(VISIBLE);
				}

				@Override
				public void onAnimationRepeat(Animation animation) {

				}

				@Override
				public void onAnimationEnd(Animation animation) {
					mHandler.postDelayed(hide, 2500);
				}
			});
			startAnimation(animation);

		}
	};

	public void doAnimationClose() {
		post(hide);
	}
	// صЧ
	Runnable hide = new Runnable() {
		public void run() {
			TranslateAnimation animation;
			int fromXDelta = 0, toXDelta = 0, fromYDelta = 0, toYDelta = 0;
			int calculatedDuration = 0;

			toXDelta = -1 * textWidth;

			calculatedDuration = mDuration * Math.abs(toXDelta - fromXDelta)
					/ textWidth;

			animation = new TranslateAnimation(fromXDelta, toXDelta,
					fromYDelta, toYDelta);
			animation.setDuration(calculatedDuration);
			animation.setAnimationListener(new AnimationListener() {

				@Override
				public void onAnimationStart(Animation animation) {

				}

				@Override
				public void onAnimationRepeat(Animation animation) {

				}

				@Override
				public void onAnimationEnd(Animation animation) {
					mHandler.postDelayed(appear, 500);
					text.setVisibility(INVISIBLE);
				}
			});
			startAnimation(animation);
		}
	};
}
